Blame elf/tst-ldconfig-X.sh

Packit 6c4009
#!/bin/sh
Packit 6c4009
# Test that ldconfig -X does not remove stale symbolic links.
Packit 6c4009
# Copyright (C) 2000-2018 Free Software Foundation, Inc.
Packit 6c4009
# This file is part of the GNU C Library.
Packit 6c4009
Packit 6c4009
# The GNU C Library is free software; you can redistribute it and/or
Packit 6c4009
# modify it under the terms of the GNU Lesser General Public
Packit 6c4009
# License as published by the Free Software Foundation; either
Packit 6c4009
# version 2.1 of the License, or (at your option) any later version.
Packit 6c4009
Packit 6c4009
# The GNU C Library is distributed in the hope that it will be useful,
Packit 6c4009
# but WITHOUT ANY WARRANTY; without even the implied warranty of
Packit 6c4009
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Packit 6c4009
# Lesser General Public License for more details.
Packit 6c4009
Packit 6c4009
# You should have received a copy of the GNU Lesser General Public
Packit 6c4009
# License along with the GNU C Library; if not, see
Packit 6c4009
# <http://www.gnu.org/licenses/>.
Packit 6c4009
Packit 6c4009
set -ex
Packit 6c4009
Packit 6c4009
common_objpfx=$1
Packit 6c4009
test_wrapper_env=$2
Packit 6c4009
run_program_env=$3
Packit 6c4009
Packit 6c4009
testroot="${common_objpfx}elf/bug19610-test-directory"
Packit 6c4009
cleanup () {
Packit 6c4009
    rm -rf "$testroot"
Packit 6c4009
}
Packit 6c4009
trap cleanup 0
Packit 6c4009
Packit 6c4009
rm -rf "$testroot"
Packit 6c4009
mkdir -p $testroot/lib $testroot/etc
Packit 6c4009
Packit 6c4009
# Relative symbolic link target.
Packit 6c4009
ln -s libdoesnotexist.so.1.1 $testroot/lib/libdoesnotexist.so.1
Packit 6c4009
Packit 6c4009
# Absolute symbolic link target.
Packit 6c4009
ln -s $testroot/opt/sw/lib/libdoesnotexist2.so.1.1 $testroot/lib/
Packit 6c4009
Packit 6c4009
errors=0
Packit 6c4009
check_files () {
Packit 6c4009
    for name in libdoesnotexist.so.1 libdoesnotexist2.so.1.1 ; do
Packit 6c4009
	path="$testroot/lib/$name"
Packit 6c4009
	if test ! -h $path ; then
Packit 6c4009
	    echo "error: missing file: $path"
Packit 6c4009
	    errors=1
Packit 6c4009
	fi
Packit 6c4009
    done
Packit 6c4009
}
Packit 6c4009
Packit 6c4009
check_files
Packit 6c4009
Packit 6c4009
${test_wrapper_env} \
Packit 6c4009
${run_program_env} \
Packit 6c4009
${common_objpfx}elf/ldconfig -X -f /dev/null \
Packit 6c4009
  -C $testroot/etc/ld.so.cache \
Packit 6c4009
  $testroot/lib
Packit 6c4009
Packit 6c4009
check_files
Packit 6c4009
Packit 6c4009
exit $errors